<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - @year@ RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * Select list form field for order status.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       6.5.0
 */
class JFormFieldCsviHikashopOrderStatus extends JFormFieldCsviForm
{
	/**
	 * Type of field
	 *
	 * @var    string
	 * @since  6.5.0
	 */
	protected $type = 'CsviHikashopOrderStatus';

	/**
	 * Get the options.
	 *
	 * @return  array  An array of order status.
	 *
	 * @since   6.5.0
	 */
	protected function getOptions()
	{
		$query     = $this->db->getQuery(true);
		$tables    = $this->db->getTableList();
		$tableName = 'hikashop_orderstatus';

		if (in_array($this->db->getPrefix() . $tableName, $tables))
		{
			$query->clear()
				->select(
					array(
						$this->db->quoteName('orderstatus_namekey', 'value'),
						$this->db->quoteName('orderstatus_name', 'text'))
				)
				->from($this->db->quoteName('#__hikashop_orderstatus'))
				->where($this->db->quoteName('orderstatus_published') . ' =  1')
				->order($this->db->quoteName('text'));

			$this->db->setQuery($query);
			$status = $this->db->loadObjectList();
		}
		else
		{
			$query->clear()
				->select(
					array(
						$this->db->quoteName('category_name', 'value'),
						$this->db->quoteName('category_name', 'text'))
				)
				->from($this->db->quoteName('#__hikashop_category'))
				->where($this->db->quoteName('category_type') . ' = ' . $this->db->quote('status'))
				->order($this->db->quoteName('text'));

			$this->db->setQuery($query);
			$status = $this->db->loadObjectList();
		}

		if (empty($status))
		{
			$status = array();
		}

		return array_merge(parent::getOptions(), $status);
	}
}
